﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
 * 
 * Exemplo de programa recursivo
 * 
 * Cálculo do Fatorial de um número
 * 
 */
namespace ConsoleRecursao1
{
    class Fatorial
    {
        /**
         * fatorial
         * 
         * Calcula o fatorial de um número
         * 
         * 0! = 1
         * 1! = 1 . 0!
         * 2! = 2 . 1! = 2 . 1 . 0!
         * ...
         * n! = n . (n-1)!
         * 
         * @param int numero número para calcular o fatorial
         * 
         * @return fat_n Fatorial do número
         * 
         */
        static int fatorial(int numero)
        {
            int fat_n;
            Console.WriteLine("Calculo de {0}!", numero);
            if (numero == 0)
            {
                // fatorial de n
                fat_n = 1; // caso trivial
                Console.WriteLine("  [Caso trivial - inicio]");
                Console.WriteLine("  {0}! = {1}", numero, fat_n);
                Console.WriteLine("  [Caso trivial - fim]");
            }
            else
            {
                // redução do problema
                // cálculo do n! = n * (n-1)!
                //
                Console.WriteLine("calculando {0}! = {1} . {2}!", numero, numero, numero-1);
                // calculo fatorial do (numero-1)
                int fat_n_1 = fatorial(numero - 1);
                // calcula o fatorial de n
                // em função do valor calculado
                // para n-1
                //
                fat_n = numero * fat_n_1;
                Console.WriteLine("{0}! = {1} . {2}! = {1} . {3} = {4}", numero,numero,numero-1,fat_n_1,fat_n);
            }
            return fat_n;
        }

        /**
         * 
         */
        static void Main(string[] args)
        {
            
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine("{0}!={1}",i,fatorial(i));
            }

            Console.WriteLine("{0}!={1}", 5, fatorial(5));
        }
    }
}
